<?php
/*
Plugin Name: mLanguage
Plugin URI: http://www.gnomx.at/mlang
Description: Adds Multilanguage Support to WP 
Version: 1.1.2
Author: Sirlon
Author URI: http://www.gnomx.at

*/

define( 'WPMLANG_VERSION', '1.1.2' );

if ( ! defined( 'WPMLANG_PLUGIN_NAME' ) )
	define( 'WPMLANG_PLUGIN_NAME', 'mlanguage');

if ( ! defined( 'WPMLANG_PLUGIN_DIR' ) )
	define( 'WPMLANG_PLUGIN_DIR', WP_PLUGIN_DIR . '/' . plugin_basename( dirname( __FILE__ ) ) );

if ( ! defined( 'WPMLANG_PLUGIN_URL' ) )
	define( 'WPMLANG_PLUGIN_URL', WP_PLUGIN_URL . '/' . plugin_basename( dirname( __FILE__ ) ) );


$defLang = array(
		0 => array ( 'lang' => 'en',
				 	 'default' => '1',
				 	 'title' => 'English',
					 'img' => 'en'),
		1 => array ( 'lang' => 'de',
				 	 'default' => '0',
				 	 'title' => 'Deutsch',
					 'img' => 'de-at'));

if ( ! defined( 'WPMLANG_DEFAULT_TITLETAG' ) )
	define( 'WPMLANG_DEFAULT_TITLETAG', 'h1' );



require_once WPMLANG_PLUGIN_DIR . '/options.php';


				 
function mlang_add_js() {
	
	echo "\n<script type=\"text/javascript\" src=\"".WPMLANG_PLUGIN_URL."/mlanguage.js\"></script>\n";
	
}

function mlang_default()
{
	global $defLang;
	$a = get_option("mlang_lang");
	
	if(empty($a))
	{
		add_option("mlang_lang", $defLang);
		$a = $defLang;
	}

	$s = substr($_SERVER["HTTP_ACCEPT_LANGUAGE"],0,2);
	
	if($_COOKIE["WPmlang"]) $s = substr($_COOKIE["WPmlang"], 0, 2);

	$override = 0;

	for ($i=0;$i<count($a);$i++)
	{
		if($s == $a[$i]['lang'] ) $override = 1;
	}
	
	if($override)
	{
		for ($i=0;$i<count($a);$i++)
		{
			if($a[$i]['lang']==$s) 	$a[$i]['default']=1;
		
			else $a[$i]['default']=0;
		}
	}
	
	return $a;
}


//_____________________________
// Check Page Content

function get_div($m, $d, $r)
{
	if($d==1) return "<div class='$r' style=''>\n".$m."\n</div>";
    else return "<div class='$r' style='display:none;'>\n".$m."\n</div>";
}


function mlang_content($content)
{
        $languages = mlang_default();
		$al = array();

	foreach ($languages as $lang)
	{
		$replace="%\[".$lang['lang'].".*(?:/([^'/]*)/)?\s*(?:/([^'/]*)/)?\s*\](.*)\[/".$lang['lang']."\]%isU";
  			if(is_feed() && $lang['default'] != 1)
			{
				$content = preg_replace($replace, " ", $content,-1, $rcount);
				$al[count($al)] = $lang['title'];
			} else {
				$content = preg_replace($replace, get_div('\\3', $lang['default'], $lang['lang']), $content );
			}
	}
	
	
	if(is_feed() && $rcount > 0){
	$content = $content."<br /><br /><br /><p><small>This Article is also available in <b>".implode(',',$al)."</b>.</small></p>";
	}

	return $content;
}

function mlang_title($title)
{
	
	$titleTag = WPMLANG_DEFAULT_TITLETAG;
	$tt = get_option("mlang_titleTag");
	if(isset($tt)) $titleTag = $tt;
	
	$id=get_the_ID();
	
	if(is_single() || is_page() || is_home() || is_category())
	{
			
	global $defLang;
	$a = get_option("mlang_lang");
	
	if(!isset($a))
	{
		add_option("mlang_lang", $defLang);
		$a = $defLang;
	}
			
		$default = 0;
	
		$c = substr($_SERVER["HTTP_ACCEPT_LANGUAGE"],0,2);
	
		if($_COOKIE["WPmlang"]) $c = $_COOKIE["WPmlang"];
		
		
			
		foreach ($a as $lang)
		{
			$l = get_post_custom($id);
						
			if($l[$lang['lang']][0])
			{
				$titolo .= '<a href="'.get_permalink().'" class="'.$lang['lang'].'" style="display:';
			
				if($lang['lang']==$c) 
				{
					$titolo.= 'block;">';
					$default = 1;
				}
				else $titolo.= 'none;">';
						
				$titolo.= $l[$lang['lang']][0]."</a>";
			}
		}
		
		if(empty($titolo)) return '<a href="'.get_permalink().'">'.$title.'</a>';
		
		foreach ($a as $lang)
		{
			if($lang['default']==1) 
			{
				$titolo .= '<a href="'.get_permalink().'" class="'.$lang['lang'].'" style="display:';
			
				if($lang['lang']==$c || $default==0) $titolo.= 'block;">';
				else $titolo.= 'none;">';
						
				$titolo .= $title."</a>";
			}	
		}
	
		return $titolo;
	}

	else return $title;
}


//_____________________________
// Menu Function

function mlang_menu()
{

		
		
		$home = get_settings('siteurl');

		$languages = mlang_default();
		
	
		foreach ($languages as $l)
		{
			
			echo " <a href=\"javascript:void(null);\" onclick=\"";
			
						if(isset($l['img']))
						{ 
							$img = $l['img'];
						}
						else
						{
							$img = $l['lang'];
							$l['img'] = $img;
						}
  							
			foreach ($languages as $u)
  				if($u['lang']!=$l['lang']) echo "mlang('".$u['lang']."',document.getElementById('".$u['lang']."u'),'$home', 1,'".$u['img']."');";
													
  			echo "mlang('".$l['lang']."', this,'$home', 0,'".$l['img']."');\" id=\"".$l['lang']."u\" title=\"".$l['title']."\">";
			echo "<img src=\"".WPMLANG_PLUGIN_URL."/img/";
                        if($l['default']!=1)echo"d";
			echo $img.".png\" id='".$l['lang']."i' border='0' alt='".$l['title']."' /></a>";
  		}  				
}	

//_____________________________
// Widget

class mLang_Widget extends WP_Widget {
	
	function mLang_Widget()
	{
		$widget_ops = array('classname' => 'widget_mlang', 'description' => 'Adds a Language Menu.' );
		parent::WP_Widget(false, $name = 'mLanguage Flag Menu', $widget_ops);
	}
	
	 function widget($args, $instance)
	{
		extract($args, EXTR_SKIP);
		
		$title = $instance['title'];
		echo $before_widget;
		if ( !empty( $title ) ) { echo $before_title . $title . $after_title; };
		mlang_menu();
		echo $after_widget; 
	}

	function update($new_instance, $old_instance)
	{
		return $new_instance;
	}
	
	function form($instance) 
	{
		$title = esc_attr($instance['title']);
        ?>
            <p><label for="<?php echo $this->get_field_id('title'); ?>"><?php _e('Title:'); ?> <input class="widefat" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" value="<?php echo $title; ?>" /></label></p>
        <?php
	} 
}
function mlang_init_widget()
{
	return register_widget('mLang_Widget');
}

//_____________________________
//Editor Plugin

function mlang_addbutton()
{
	if ( ! current_user_can('edit_posts') && ! current_user_can('edit_pages') )
     return;
 
   if ( get_user_option('rich_editing') == 'true') {
    	add_filter("mce_external_plugins", "add_mlang_tinymce_plugin");
     	add_filter("mce_buttons", "register_mlang_button");
   }	
}

function register_mlang_button($buttons) 
{
   array_push($buttons, "separator", "mlang");
   return $buttons;
}

function add_mlang_tinymce_plugin($plugin_array) {
   $plugin_array['mlang'] = WPMLANG_PLUGIN_URL."/editor_plugin.js";
   return $plugin_array;
}

//_____________________________
// Register with WP
add_action('wp_head', 'mlang_add_js');
add_action('widgets_init', 'mlang_init_widget');
add_action('init', 'mlang_addbutton');

add_filter('the_content', 'mlang_content', 2);
add_filter('the_title', 'mlang_title');

?>