<?php
/*
Admin Menu of wp-mLang
*/

function mlang_config_menu() 
{
    add_options_page("mLang", "mLanguage", 8, __FILE__, "mlang_menu_page");
}

function array_remove(&$a_Input, $m_SearchValue, $b_Strict = False) {
    $a_Keys = array_keys($a_Input, $m_SearchValue, $b_Strict);
    foreach($a_Keys as $s_Key) {
        unset($a_Input[$s_Key]);
    }
    return $a_Input;
	}

function mlang_setdef_lang($array, $newdef)
{	
	for ($i=0;$i<count($array);$i++)
	{
		if($newdef == $array[$i]['lang'] )
		{
			$array[$i]['default'] = 1;
		}
		else
		{
			$array[$i]['default'] = 0;
		}
	}
	return $array;
}

function mlang_menu_page()
{	
	
	
	$hidden_field_name = "mt_submit_hidden";
	$lang_field_name = "mt_submit_lang";
	$default_checker_name = "mt_submit_default";
	$title_field_name = "mt_submit_title";
	
    //Get Options
	
	
	$langArray = array(
		0 => array ( 'lang' => 'en',
				 	 'default' => '1',
				 	 'title' => 'English',
					 'img' => 'en'),
		1 => array ( 'lang' => 'de',
				 	 'default' => '0',
				 	 'title' => 'Deutsch',
					 'img' => 'de-at'));
	
	$la = get_option("mlang_lang");
	
	if(empty($la))
	{
		add_option("mlang_lang",$langArray);
		$a = $defLang;
	} else {
	$langArray = $la;	
	}
	
	
	if( $_REQUEST['action'] == 'delete')
	{
		$dlang = $_REQUEST['lang'];
		
		foreach($langArray as $key)
		{
			if($key['lang'] == $dlang){
				array_remove($langArray, array ( 'lang' => $key['lang'],
				 	 'default' => $key['default'],
				 	 'title' => $key['title'],
					 'img' => $key['img']), true);
			?><div class="updated"><p><strong><?php _e('Language '.$dlang.' deleted.', 'mlang' ); ?></strong></p></div> <?php
			}
		}
		update_option("mlang_lang", $langArray );
		
	} 
	
	if($_REQUEST['action'] == 'edit')
	{
		$elang = $_REQUEST['lang'];
		foreach($langArray as $key)
		{
			if($key['lang'] == $elang)
			{
				$edef = $key['default'];
				$etitle = $key['title'];
				if(isset($key['img']))
						{ 
							$eimg = $key['img'];						}
						else
						{
							$eimg = $l['lang'];
						}
				
			}
		}
	}
	
	if( $_POST[ $hidden_field_name ] == 'U' ) {
		$lang = $_POST[ $lang_field_name ];
		$def =  $_POST[ $default_checker_name ] or 0;
		$title = $_POST[ $title_field_name ];
		$flag = $_POST[ 'flag_option' ];
		
		
		if(isset($title)){
			
			for ($i=0;$i<count($langArray);$i++)
			{
				if($lang == $langArray[$i]['lang'] )
				{
					$langArray[$i]['title'] = $title;
					if($def == 1) $langArray = mlang_setdef_lang($langArray, $lang);
					else $langArray[$i]['default'] = 0;
					$langArray[$i]['img'] = $flag;
				}
			}
			
			$defset = 0;
			foreach($langArray as $i)
			{
				if($i['default'] == 1)
				{
					$defset = $defset + 1;
				}
			}
			
			if($defset == 1)
			{
				update_option("mlang_lang", $langArray);
				?>
				<div class="updated"><p><strong><?php _e('Tag Updated.', 'mlang' ); ?></strong></p></div>
			<?php
			} else {
			?><div class="error"><p><strong><?php _e('There is no or to many default Language(s) defined. Please define one.', 'mlang' ); ?></strong></p></div><?php
			}
		}
	}
	if( $_POST[ $hidden_field_name ] == 'Y' ) {
		$lang = $_POST[ $lang_field_name ];
		$def =  $_POST[ $default_checker_name ] or 0;
		$title = $_POST[ $title_field_name ];
		
		if(isset($lang) && isset($title)){
		$newEntry = array(
						'lang' => $lang,
				 	 	'default' => $def,
				 	 	'title' => $title,
						'img' => $lang);
		$save = true;
		foreach($langArray as $a)
		{
			if($a['lang'] == $lang){
				$save = false;
				break;
			}
		}
		if($save){
			$langArray[count($langArray)] = $newEntry;
			
			if($def == 1) $langArray = mlang_setdef_lang($langArray, $lang);
			
			update_option("mlang_lang", $langArray );

        // Put an options updated message on the screen

		?>
			<div class="updated"><p><strong><?php _e('Options saved.', 'mlang' ); ?></strong></p></div>
		<?php
		} else { ?>
        	<div class="error"><p><strong><?php _e('There is already a Language with that Tag.', 'mlang' ); ?></strong></p></div>
        <?php
		}
    }
	}
	?>
    <div class="wrap">
    <h2>WP mLanguage Options</h2>
    <p>
    	<?php if($_REQUEST['action'] == 'edit') _e("<span style=\"text-align:left\"><a href=\"?page=mlanguage/options.php\" title=\"Add New Tag\">Add New Language Tag</a></span>"); ?>
    	<table class="widefat" style="margin-top:4px;" width="300px">
        <thead>
        	<tr>
            	<th scope="col" width="180px">Language</th>
                <th scope="col" style="text-align:center" width="35px">Default</th>
                <th scope="col" style="text-align:center" width="35px">Tag</th>
                <th scope="col" style="text-align:center" width="35px">Flag</th>
                <th scope="col" style="text-align:center" width="50px">Actions</th>
            </tr>
        </thead>
        <tbody id="the-list">
        <?php
        	foreach($langArray as $a)
			{	
				if(isset($a)){
				$d = 0;
				if(isset($a['img']))
						{ 
							$img = $a['img'];
						}
						else
						{
							$img = $a['lang'];
							$a['img'] = $img;
						}
				if($a['default']==1) $d = x;
				echo"<tr class=\"alternate\">
					  <td style=\"text-align:left;\" width=\"145px\" >".$a['title']."</td>
					  <td style=\"text-align:center;\" width=\"35px\" >".$d."</td>
					  <td style=\"text-align:center;\" width=\"35px\">".$a['lang']."</td>
					  <td style=\"text-align:center;\" width=\"35px\"><img src=\"".WPMLANG_PLUGIN_URL."/img/".$img.".png\" title=\"Flag\" /></td>
					  <td style=\"text-align:center;\" width=\"50px\"><a href=\"?page=mlanguage/options.php&action=edit&lang=".$a['lang']."\" title=\"Edit\">Edit</a>&nbsp;&brvbar;&nbsp;<a href=\"?page=mlanguage/options.php&action=delete&lang=".$a['lang']."\" title=\"Delete\">Delete</a></td>
				</tr>";	
				}
			} 
		?>
        </tbody>
        </table>
    </p>
    <p>
     <fieldset style="border:solid 1px #888; margin-top:20px; padding-left:10px;">
    <legend style="margin:-10px 5px 0 0"><h3><?php if($_REQUEST['action'] == 'edit')_e('Edit Language', 'mlang' ); else _e('Add Language', 'mlang' );?></h3></legend>
    <form style="margin-top:5px;" name="form1" method="post" action="?page=mlanguage/options.php">
    <input type="hidden" name="<?php echo $hidden_field_name; ?>" value="<?php if($_REQUEST['action'] == 'edit') echo"U"; else echo"Y"; ?>" />
     <p>
    <label title="Language Name"><b>Language Name</b></label><br />
    <input type="text" name="<?php echo $title_field_name; ?>" value="<?php if($_REQUEST['action'] == 'edit') echo $etitle; else echo""; ?>" />
    </p>
    <p>
    <label><b>Language Tag</b></label><br />
    <input type="text" maxlength="2" name="<?php echo $lang_field_name; ?>"  value="<?php if($_REQUEST['action'] == 'edit') echo $elang.'" readonly="readonly"'; else echo""; ?>" /></p>
    <p>
    <label><b>Default Language</b></label><br />
    <input type="checkbox" name="<?php echo $default_checker_name; ?>" value="1" <?php if($_REQUEST['action'] == 'edit') { if($edef == 1) echo'checked=\"checked\"'; } ?> /></p>
    <?php 
	if($_REQUEST['action'] == 'edit') {
		echo "<p><label><b>Flag:</b></label><br />";
		if ($handle = opendir(WPMLANG_PLUGIN_DIR . '/img/')) 
		{
			$count = 0;
		
			while (false !== ($file = readdir($handle))) 
			{
				$fname = str_replace('.png', '', $file);
				if($fname == $elang || substr($fname, 0, 3) == $elang."-")
				{
					?>
                    <label><img src="<?php echo WPMLANG_PLUGIN_URL."/img/".$file; ?>" title="<?php echo $fname; ?>"/><input type="radio" name="flag_option" id="flag_opion_<?php echo $count; ?>" value="<?php  echo $fname; ?>" <?php if($fname == $eimg) echo'checked="checked"'; ?> /></label>&nbsp;
                    <?php
					$count++;
				}
			}
			closedir($handle);
		}
		echo "</p>";
	} 
	?>
    
    <p class="submit">
	<input type="submit" name="Submit" value="<?php if($_REQUEST['action'] == 'edit') _e('Update Tag', 'mlang' );  else _e('Add Tag', 'mlang' ); ?>" />
	</p>
    </form>
    </fieldset>
    </p>
    <br />
    <h2>How to use?</h2>
    <p>You have only to write post, tagging each language:</p>
<p style="font-style:italic">
eg. [de]Deutsch[/de] [en]English[/en]
</p>
<p>
For <b>titles</b>, you have to write as normal title inside post, the one in the language you have set as default.
</p>
Then you have only to scroll till Custom Fields and add:
<p>key: the short tag of the language ( eg. de or en, etc )<br />
value: the title text.</p>
<hr />
<small style="color:#999">Need help? FAQ, Usage instructions and other notes can be found on the plugin page <a href="http://www.gnomx.at/mlang">here.</a></small>
    </div>
    <?php
}

add_action("admin_menu","mlang_config_menu"); 
?>